// Version: 1.0
// Author: JD
// Vendor: Actel
// Date: Thu Jul 21 19:25:51 PDT 2005
// Comment: Black Box model of the Arm Core with Timing Information


module A7S(CLK, CLKEN, nRESET,
ABORT, CFGBIGEND, CPA, CPB, DBGBREAK, DBGEN, DBGnTRST, DBGRQ, DBGTCKEN, DBGTDI, DBGTMS, nFIQ, nIRQ, RDATA, DBGEXT,
DMORE, LOCK, WRITE, ADDR, WDATA, SIZE, PROT, TRANS,
CPnI, CPnMREQ, CPnOPC, CPSEQ, CPTBIT, CPnTRANS,
DBGACK, DBGCOMMRX, DBGCOMMTX, DBGINSTRVALID, DBGnEXEC, DBGRNG, DBGnTDOEN, DBGTDO)

/* synthesis syn_black_box

syn_tco0 = " CLK->ADDR[31:0] = 42.59 "
syn_tco1 = " CLK->WDATA[31:0] = 18.51 "
syn_tco2 = " CLK->WRITE = 41.66 "
syn_tco3 = " CLK->SIZE[1:0] = 41.66 "
syn_tco4 = " CLK->PROT[1:0] = 41.66 "
syn_tco5 = " CLK->TRANS[1:0] = 23.14 "
syn_tco6 = " CLK->CPnMREQ = 39.35 "
syn_tco7 = " CLK->CPnOPC = 39.35 "
syn_tco8 = " CLK->CPSEQ = 39.35 "
syn_tco9 = " CLK->CPTBIT = 41.66 "
syn_tco10 = " CLK->CPnTRANS = 39.35 "
syn_tco11 = " CLK->CPnI = 18.51 "
syn_tco12 = " CLK->DBGACK = 18.51 "
syn_tco13 = " CLK->DBGCOMMRX = 18.51 "
syn_tco14 = " CLK->DBGCOMMTX = 18.51 "
syn_tco15 = " CLK->DBGINSTRVALID = 18.51 "
syn_tco16 = " CLK->DBGnEXEC = 18.51 "
syn_tco17 = " CLK->DBGRNG[1:0] = 18.51 "
syn_tco18 = " CLK->DBGnTDOEN = 9.25 "
syn_tco19 = " CLK->DBGTDO = 9.25 "
syn_tco20 = " CLK->DMORE = 41.66 "
syn_tco21 = " CLK->LOCK = 41.66 "

syn_tsu0 = " CLKEN->CLK = 27.77 "
syn_tsu1 = " DBGTCKEN->CLK = 27.77 "
syn_tsu2 = " DBGTDI->CLK = 16.2 "
syn_tsu3 = " DBGTMS->CLK = 16.2 "
syn_tsu4 = " CPA->CLK = 9.25 "
syn_tsu5 = " CPB->CLK = 9.25 "
syn_tsu6 = " ABORT->CLK = 18.51 "
syn_tsu7 = " RDATA[31:0]->CLK = 4.62 "
syn_tsu8 = " CFGBIGEND->CLK = 4.62 "
syn_tsu9 = " DBGBREAK->CLK = 4.62 "
syn_tsu10 = " DBGnTRST->CLK = 11.57 "
syn_tsu11 = " DBGRQ->CLK = 4.62 "
syn_tsu12 = " DBGEXT[1:0]->CLK = 4.62 "
syn_tsu13 = " nFIQ->CLK = 4.62 "
syn_tsu14 = " nIRQ->CLK = 4.62 "
syn_tsu15 = " nRESET->CLK = 41.66 "

syn_scaletiming = "actel_blackbox_scaling"
syn_resources = "corecells = 7931 , rams = 4 , plls = 0 , fifos = 0 , global_clocks = 3 , quadrant_clocks = 0 "

*/;


input CLK, CLKEN, nRESET;
input ABORT, CFGBIGEND, CPA, CPB, DBGBREAK, DBGEN, DBGnTRST, DBGRQ, DBGTCKEN, DBGTDI, DBGTMS, nFIQ, nIRQ;
input [31:0] RDATA;
input [1:0] DBGEXT;
output DMORE, LOCK, WRITE;
output [31:0] ADDR, WDATA;
output [1:0] SIZE, PROT, TRANS, DBGRNG;
output CPnI, CPnMREQ, CPnOPC, CPSEQ, CPTBIT, CPnTRANS,
DBGACK, DBGCOMMRX, DBGCOMMTX, DBGINSTRVALID, DBGnEXEC, DBGnTDOEN, DBGTDO;


endmodule


