// Version: 1.0
// Author: JD
// Vendor: Actel
// Date: Thu Jul 21 19:25:51 PDT 2005
// Comment: Black Box model of the Arm Core with Timing Information


module A7S(CLK, CLKEN, nRESET,
ABORT, CFGBIGEND, CPA, CPB, DBGBREAK, DBGEN, DBGnTRST, DBGRQ, DBGTCKEN, DBGTDI, DBGTMS, nFIQ, nIRQ, RDATA, DBGEXT,
DMORE, LOCK, WRITE, ADDR, WDATA, SIZE, PROT, TRANS,
CPnI, CPnMREQ, CPnOPC, CPSEQ, CPTBIT, CPnTRANS,
DBGACK, DBGCOMMRX, DBGCOMMTX, DBGINSTRVALID, DBGnEXEC, DBGRNG, DBGnTDOEN, DBGTDO)


/*
synthesis syn_black_box

syn_tco0 = " CLK->ADDR[31:0] = 34.21 "
syn_tco1 = " CLK->WDATA[31:0] = 14.87 "
syn_tco2 = " CLK->WRITE = 33.46 "
syn_tco3 = " CLK->SIZE[1:0] = 33.46 "
syn_tco4 = " CLK->PROT[1:0] = 33.46 "
syn_tco5 = " CLK->TRANS[1:0] = 18.59 "
syn_tco6 = " CLK->CPnMREQ = 31.6 "
syn_tco7 = " CLK->CPnOPC = 31.6 "
syn_tco8 = " CLK->CPSEQ = 31.6 "
syn_tco9 = " CLK->CPTBIT = 33.46 "
syn_tco10 = " CLK->CPnTRANS = 31.6 "
syn_tco11 = " CLK->CPnI = 14.87 "
syn_tco12 = " CLK->DBGACK = 14.87 "
syn_tco13 = " CLK->DBGCOMMRX = 14.87 "
syn_tco14 = " CLK->DBGCOMMTX = 14.87 "
syn_tco15 = " CLK->DBGINSTRVALID = 14.87 "
syn_tco16 = " CLK->DBGnEXEC = 14.87 "
syn_tco17 = " CLK->DBGRNG[1:0] = 14.87 "
syn_tco18 = " CLK->DBGnTDOEN = 7.43 "
syn_tco19 = " CLK->DBGTDO = 7.43 "
syn_tco20 = " CLK->DMORE = 33.46 "
syn_tco21 = " CLK->LOCK = 33.46 "

syn_tsu0 = " CLK->CLKEN = 22.31 "
syn_tsu1 = " CLK->DBGTCKEN = 22.31 "
syn_tsu2 = " CLK->DBGTDI = 13.01 "
syn_tsu3 = " CLK->DBGTMS = 13.01 "
syn_tsu4 = " CLK->CPA = 7.43 "
syn_tsu5 = " CLK->CPB = 7.43 "
syn_tsu6 = " CLK->ABORT = 14.87 "
syn_tsu7 = " CLK->RDATA[31:0] = 3.71 "
syn_tsu8 = " CLK->CFGBIGEND = 3.71 "
syn_tsu9 = " CLK->DBGBREAK = 3.71 "
syn_tsu10 = " CLK->DBGnTRST = 9.29 "
syn_tsu11 = " CLK->DBGRQ = 3.71 "
syn_tsu12 = " CLK->DBGEXT[1:0] = 3.71 "
syn_tsu13 = " CLK->nFIQ = 3.71 "
syn_tsu14 = " CLK->nIRQ = 3.71 "
syn_tsu15 = " CLK->nRESET = 33.46 "

syn_scaletiming = "actel_blackbox_scaling"
syn_resources = "corecells = 6035 , rams = 4 , plls = 0 , fifos = 0 , global_clocks = 2 , quadrant_clocks = 0 "

*/;


input CLK, CLKEN, nRESET;
input ABORT, CFGBIGEND, CPA, CPB, DBGBREAK, DBGEN, DBGnTRST, DBGRQ, DBGTCKEN, DBGTDI, DBGTMS, nFIQ, nIRQ;
input [31:0] RDATA;
input [1:0] DBGEXT;
output DMORE, LOCK, WRITE;
output [31:0] ADDR, WDATA;
output [1:0] SIZE, PROT, TRANS, DBGRNG;
output CPnI, CPnMREQ, CPnOPC, CPSEQ, CPTBIT, CPnTRANS,
DBGACK, DBGCOMMRX, DBGCOMMTX, DBGINSTRVALID, DBGnEXEC, DBGnTDOEN, DBGTDO;


endmodule

