/*                    Copyright: Actel Corporation                         */
`timescale 1ns/10ps
module
CoreMP7Bridge_Il1I
(
NSYSRESET
,
HCLK
,
HRESETn
,
WDOGRES
,
WDOGRESn
,
nIRQ_in
,
nFIQ_in
,
CoreMP7Bridge_IIlI
,
CoreMP7Bridge_lIlI
,
RV_TCK
,
RV_nTRST
,
RV_TMS
,
RV_TDI
,
RV_nSRST_IN
,
RV_RTCK
,
DBGTCKEN
,
DBGnTRST
,
DBGTMS
,
DBGTDI
)
;
input
NSYSRESET
;
input
HCLK
;
output
HRESETn
;
reg
HRESETn
;
input
WDOGRES
;
output
WDOGRESn
;
reg
WDOGRESn
;
input
nIRQ_in
;
input
nFIQ_in
;
output
CoreMP7Bridge_IIlI
;
reg
CoreMP7Bridge_IIlI
;
output
CoreMP7Bridge_lIlI
;
reg
CoreMP7Bridge_lIlI
;
input
RV_TCK
;
input
RV_nTRST
;
input
RV_TMS
;
input
RV_TDI
;
input
RV_nSRST_IN
;
output
RV_RTCK
;
reg
RV_RTCK
;
output
DBGTCKEN
;
wire
DBGTCKEN
;
output
DBGnTRST
;
reg
DBGnTRST
;
output
DBGTMS
;
reg
DBGTMS
;
output
DBGTDI
;
reg
DBGTDI
;
reg
CoreMP7Bridge_O01I
;
reg
CoreMP7Bridge_I01I
;
reg
CoreMP7Bridge_l01I
;
reg
CoreMP7Bridge_O11I
;
reg
CoreMP7Bridge_I11I
;
reg
CoreMP7Bridge_l11I
;
reg
CoreMP7Bridge_OOOl
;
wire
CoreMP7Bridge_IOOl
;
wire
CoreMP7Bridge_lOOl
;
wire
CoreMP7Bridge_OIOl
;
assign
CoreMP7Bridge_IOOl
=
RV_nSRST_IN
&&
NSYSRESET
&&
!
WDOGRES
;
always
@
(
posedge
HCLK
or
negedge
CoreMP7Bridge_IOOl
)
begin
if
(
!
CoreMP7Bridge_IOOl
)
begin
CoreMP7Bridge_O01I
<=
1
'b
0
;
HRESETn
<=
1
'b
0
;
end
else
begin
CoreMP7Bridge_O01I
<=
1
'b
1
;
HRESETn
<=
CoreMP7Bridge_O01I
;
end
end
assign
CoreMP7Bridge_lOOl
=
RV_nSRST_IN
&&
NSYSRESET
;
always
@
(
posedge
HCLK
or
negedge
CoreMP7Bridge_lOOl
)
begin
if
(
!
CoreMP7Bridge_lOOl
)
begin
CoreMP7Bridge_I01I
<=
1
'b
0
;
WDOGRESn
<=
1
'b
0
;
end
else
begin
CoreMP7Bridge_I01I
<=
1
'b
1
;
WDOGRESn
<=
CoreMP7Bridge_I01I
;
end
end
always
@
(
posedge
HCLK
or
negedge
HRESETn
)
begin
if
(
!
HRESETn
)
begin
CoreMP7Bridge_l01I
<=
1
'b
1
;
CoreMP7Bridge_IIlI
<=
1
'b
1
;
end
else
begin
CoreMP7Bridge_l01I
<=
nIRQ_in
;
CoreMP7Bridge_IIlI
<=
CoreMP7Bridge_l01I
;
end
end
always
@
(
posedge
HCLK
or
negedge
HRESETn
)
begin
if
(
!
HRESETn
)
begin
CoreMP7Bridge_O11I
<=
1
'b
1
;
CoreMP7Bridge_lIlI
<=
1
'b
1
;
end
else
begin
CoreMP7Bridge_O11I
<=
nFIQ_in
;
CoreMP7Bridge_lIlI
<=
CoreMP7Bridge_O11I
;
end
end
always
@
(
posedge
HCLK
or
negedge
RV_nTRST
)
begin
if
(
!
RV_nTRST
)
begin
CoreMP7Bridge_I11I
<=
1
'b
0
;
DBGnTRST
<=
1
'b
0
;
end
else
begin
CoreMP7Bridge_I11I
<=
1
'b
1
;
DBGnTRST
<=
CoreMP7Bridge_I11I
;
end
end
always
@
(
posedge
HCLK
or
negedge
DBGnTRST
)
begin
if
(
!
DBGnTRST
)
begin
CoreMP7Bridge_l11I
<=
1
'b
0
;
CoreMP7Bridge_OOOl
<=
1
'b
0
;
RV_RTCK
<=
1
'b
0
;
end
else
begin
CoreMP7Bridge_l11I
<=
RV_TCK
;
CoreMP7Bridge_OOOl
<=
CoreMP7Bridge_l11I
;
RV_RTCK
<=
CoreMP7Bridge_OOOl
;
end
end
assign
DBGTCKEN
=
!
CoreMP7Bridge_OOOl
&&
RV_RTCK
;
assign
CoreMP7Bridge_OIOl
=
CoreMP7Bridge_OOOl
&&
!
RV_RTCK
;
always
@
(
posedge
HCLK
or
negedge
DBGnTRST
)
begin
if
(
!
DBGnTRST
)
begin
DBGTMS
<=
1
'b
0
;
DBGTDI
<=
1
'b
0
;
end
else
if
(
CoreMP7Bridge_OIOl
)
begin
DBGTMS
<=
RV_TMS
;
DBGTDI
<=
RV_TDI
;
end
else
begin
DBGTMS
<=
DBGTMS
;
DBGTDI
<=
DBGTDI
;
end
end
endmodule
