//////////////////////////////////////////////////////////////////////
// Created by Actel CoreConsole - Thu Jan 04 10:38:02 2007
//////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module Example(
    // Inputs
    APBmslave0_PRDATA,
    NSYSRESET,
    RV_ICE_If_RV_TCK,
    RV_ICE_If_RV_TDI,
    RV_ICE_If_RV_TMS,
    RV_ICE_If_RV_nSRST_IN,
    RV_ICE_If_RV_nTRST,
    Remap,
    SYSCLK,
    UJTAG_UJTAG_TCK,
    UJTAG_UJTAG_TDI,
    UJTAG_UJTAG_TMS,
    UJTAG_UJTAG_TRSTB,
    // Outputs
    APBmslave0_PADDR,
    APBmslave0_PENABLE,
    APBmslave0_PSELx,
    APBmslave0_PWDATA,
    APBmslave0_PWRITE,
    ExternalMemoryInterface_FlashCSN,
    ExternalMemoryInterface_FlashOEnN,
    ExternalMemoryInterface_FlashWEnN,
    ExternalMemoryInterface_MemAddr,
    ExternalMemoryInterface_MemReadN,
    ExternalMemoryInterface_MemWriteN,
    ExternalMemoryInterface_SramByteN,
    ExternalMemoryInterface_SramCSN,
    ExternalMemoryInterface_SramClk,
    ExternalMemoryInterface_SramOEnN,
    ExternalMemoryInterface_SramWEnN,
    HRESETN,
    RV_ICE_If_RV_RTCK,
    RV_ICE_If_RV_TDOUT,
    RV_ICE_If_RV_nTDOEN,
    UJTAG_UJTAG_TDO,
    // Inouts
    ExternalMemoryInterface_MemData
);

//--------------------------------------------------------------------
// Inputs
//--------------------------------------------------------------------

input [31:0] APBmslave0_PRDATA;
input NSYSRESET;
input RV_ICE_If_RV_TCK;
input RV_ICE_If_RV_TDI;
input RV_ICE_If_RV_TMS;
input RV_ICE_If_RV_nSRST_IN;
input RV_ICE_If_RV_nTRST;
input Remap;
input SYSCLK;
input UJTAG_UJTAG_TCK;
input UJTAG_UJTAG_TDI;
input UJTAG_UJTAG_TMS;
input UJTAG_UJTAG_TRSTB;

//--------------------------------------------------------------------
// Outputs
//--------------------------------------------------------------------

output [23:0] APBmslave0_PADDR;
output APBmslave0_PENABLE;
output APBmslave0_PSELx;
output [31:0] APBmslave0_PWDATA;
output APBmslave0_PWRITE;
output ExternalMemoryInterface_FlashCSN;
output ExternalMemoryInterface_FlashOEnN;
output ExternalMemoryInterface_FlashWEnN;
output [27:0] ExternalMemoryInterface_MemAddr;
output ExternalMemoryInterface_MemReadN;
output ExternalMemoryInterface_MemWriteN;
output [3:0] ExternalMemoryInterface_SramByteN;
output ExternalMemoryInterface_SramCSN;
output ExternalMemoryInterface_SramClk;
output ExternalMemoryInterface_SramOEnN;
output ExternalMemoryInterface_SramWEnN;
output HRESETN;
output RV_ICE_If_RV_RTCK;
output RV_ICE_If_RV_TDOUT;
output RV_ICE_If_RV_nTDOEN;
output UJTAG_UJTAG_TDO;

//--------------------------------------------------------------------
// Inouts
//--------------------------------------------------------------------

inout [31:0] ExternalMemoryInterface_MemData;

//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------

wire [31:0] AHBmaster_HADDR;
wire [2:0] AHBmaster_HBURST;
wire [3:0] AHBmaster_HPROT;
wire [31:0] AHBmaster_HRDATA;
wire AHBmaster_HREADY;
wire [1:0] AHBmaster_HRESP;
wire [2:0] AHBmaster_HSIZE;
wire [1:0] AHBmaster_HTRANS;
wire [31:0] AHBmaster_HWDATA;
wire AHBmaster_HWRITE;
wire [31:0] AHBmslave0_HRDATA;
wire AHBmslave0_HREADYOUT;
wire [1:0] AHBmslave0_HRESP;
wire AHBmslave0_HSELx;
wire [31:0] AHBmslave15_HRDATA;
wire AHBmslave15_HREADYOUT;
wire [1:0] AHBmslave15_HRESP;
wire AHBmslave15_HSELx;
wire [31:0] AHBmslave1_00_HRDATA;
wire AHBmslave1_00_HREADYOUT;
wire [1:0] AHBmslave1_00_HRESP;
wire AHBmslave1_00_HSELx;
wire [23:0] APBmaster_PADDR;
wire APBmaster_PENABLE;
wire [31:0] APBmaster_PRDATA;
wire [15:0] APBmaster_PSELECT;
wire [31:0] APBmaster_PWDATA;
wire APBmaster_PWRITE;
wire [31:0] CoreAHBLite_00_HADDRS;
wire CoreAHBLite_00_HREADYS;
wire [2:0] CoreAHBLite_00_HSIZES;
wire [1:0] CoreAHBLite_00_HTRANSS;
wire [31:0] CoreAHBLite_00_HWDATAS;
wire CoreAHBLite_00_HWRITES;
wire MP7_SysIf_ABORT;
wire [31:0] MP7_SysIf_ADDR;
wire MP7_SysIf_CLK;
wire MP7_SysIf_CLKEN;
wire MP7_SysIf_DBGTCKEN;
wire MP7_SysIf_DBGTDI;
wire MP7_SysIf_DBGTDO;
wire MP7_SysIf_DBGTMS;
wire MP7_SysIf_DBGnTDOEN;
wire MP7_SysIf_DBGnTRST;
wire MP7_SysIf_LOCK;
wire [1:0] MP7_SysIf_PROT;
wire [31:0] MP7_SysIf_RDATA;
wire [1:0] MP7_SysIf_SIZE;
wire [1:0] MP7_SysIf_TRANS;
wire [31:0] MP7_SysIf_WDATA;
wire MP7_SysIf_WRITE;
wire MP7_SysIf_nFIQ;
wire MP7_SysIf_nIRQ;
wire MP7_SysIf_nRESET;

//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------

CoreAHB2APB CoreAHB2APB_00(
        // Inputs
        .HADDR(CoreAHBLite_00_HADDRS[27:0]),
        .HCLK(SYSCLK),
        .HREADY(CoreAHBLite_00_HREADYS),
        .HRESETn(HRESETN),
        .HSEL(AHBmslave15_HSELx),
        .HTRANS(CoreAHBLite_00_HTRANSS),
        .HWDATA(CoreAHBLite_00_HWDATAS),
        .HWRITE(CoreAHBLite_00_HWRITES),
        .PRDATA(APBmaster_PRDATA),
        // Outputs
        .HRDATA(AHBmslave15_HRDATA),
        .HREADYOUT(AHBmslave15_HREADYOUT),
        .HRESP(AHBmslave15_HRESP),
        .PADDR(APBmaster_PADDR),
        .PENABLE(APBmaster_PENABLE),
        .PSELECT(APBmaster_PSELECT),
        .PWDATA(APBmaster_PWDATA),
        .PWRITE(APBmaster_PWRITE)
    );

//--------------------------------------------------------------------

CoreAHBLite #(
        // Configuration parameters
        .AhbSlot0Enable(1), 
        .AhbSlot10Enable(0), 
        .AhbSlot11Enable(0), 
        .AhbSlot12Enable(0), 
        .AhbSlot13Enable(0), 
        .AhbSlot14Enable(0), 
        .AhbSlot15Enable(1), 
        .AhbSlot1Enable(1), 
        .AhbSlot2Enable(0), 
        .AhbSlot3Enable(0), 
        .AhbSlot4Enable(0), 
        .AhbSlot5Enable(0), 
        .AhbSlot6Enable(0), 
        .AhbSlot7Enable(0), 
        .AhbSlot8Enable(0), 
        .AhbSlot9Enable(0)
    )
    CoreAHBLite_00(
        // Inputs
        .HADDR(AHBmaster_HADDR),
        .HBURST(AHBmaster_HBURST),
        .HCLK(SYSCLK),
        .HPROT(AHBmaster_HPROT),
        .HRDATAS0(AHBmslave0_HRDATA),
        .HRDATAS1(AHBmslave1_00_HRDATA),
        .HRDATAS10({32{1'b0}}),
        .HRDATAS11({32{1'b0}}),
        .HRDATAS12({32{1'b0}}),
        .HRDATAS13({32{1'b0}}),
        .HRDATAS14({32{1'b0}}),
        .HRDATAS15(AHBmslave15_HRDATA),
        .HRDATAS2({32{1'b0}}),
        .HRDATAS3({32{1'b0}}),
        .HRDATAS4({32{1'b0}}),
        .HRDATAS5({32{1'b0}}),
        .HRDATAS6({32{1'b0}}),
        .HRDATAS7({32{1'b0}}),
        .HRDATAS8({32{1'b0}}),
        .HRDATAS9({32{1'b0}}),
        .HREADYS0(AHBmslave0_HREADYOUT),
        .HREADYS1(AHBmslave1_00_HREADYOUT),
        .HREADYS10({1{1'b1}}),
        .HREADYS11({1{1'b1}}),
        .HREADYS12({1{1'b1}}),
        .HREADYS13({1{1'b1}}),
        .HREADYS14({1{1'b1}}),
        .HREADYS15(AHBmslave15_HREADYOUT),
        .HREADYS2({1{1'b1}}),
        .HREADYS3({1{1'b1}}),
        .HREADYS4({1{1'b1}}),
        .HREADYS5({1{1'b1}}),
        .HREADYS6({1{1'b1}}),
        .HREADYS7({1{1'b1}}),
        .HREADYS8({1{1'b1}}),
        .HREADYS9({1{1'b1}}),
        .HRESETn(HRESETN),
        .HRESPS0(AHBmslave0_HRESP),
        .HRESPS1(AHBmslave1_00_HRESP),
        .HRESPS10({2{1'b0}}),
        .HRESPS11({2{1'b0}}),
        .HRESPS12({2{1'b0}}),
        .HRESPS13({2{1'b0}}),
        .HRESPS14({2{1'b0}}),
        .HRESPS15(AHBmslave15_HRESP),
        .HRESPS2({2{1'b0}}),
        .HRESPS3({2{1'b0}}),
        .HRESPS4({2{1'b0}}),
        .HRESPS5({2{1'b0}}),
        .HRESPS6({2{1'b0}}),
        .HRESPS7({2{1'b0}}),
        .HRESPS8({2{1'b0}}),
        .HRESPS9({2{1'b0}}),
        .HSIZE(AHBmaster_HSIZE),
        .HTRANS(AHBmaster_HTRANS),
        .HWDATA(AHBmaster_HWDATA),
        .HWRITE(AHBmaster_HWRITE),
        .Remap(Remap),
        // Outputs
        .HADDRS(CoreAHBLite_00_HADDRS),
        .HBURSTS(),
        .HPROTS(),
        .HRDATA(AHBmaster_HRDATA),
        .HREADY(AHBmaster_HREADY),
        .HREADYS(CoreAHBLite_00_HREADYS),
        .HRESP(AHBmaster_HRESP),
        .HSELS0(AHBmslave0_HSELx),
        .HSELS1(AHBmslave1_00_HSELx),
        .HSELS10(),
        .HSELS11(),
        .HSELS12(),
        .HSELS13(),
        .HSELS14(),
        .HSELS15(AHBmslave15_HSELx),
        .HSELS2(),
        .HSELS3(),
        .HSELS4(),
        .HSELS5(),
        .HSELS6(),
        .HSELS7(),
        .HSELS8(),
        .HSELS9(),
        .HSIZES(CoreAHBLite_00_HSIZES),
        .HTRANSS(CoreAHBLite_00_HTRANSS),
        .HWDATAS(CoreAHBLite_00_HWDATAS),
        .HWRITES(CoreAHBLite_00_HWRITES)
    );

//--------------------------------------------------------------------

CoreAPB #(
        // Configuration parameters
        .ApbSlot0Enable(1), 
        .ApbSlot10Enable(0), 
        .ApbSlot11Enable(0), 
        .ApbSlot12Enable(0), 
        .ApbSlot13Enable(0), 
        .ApbSlot14Enable(0), 
        .ApbSlot15Enable(0), 
        .ApbSlot1Enable(0), 
        .ApbSlot2Enable(0), 
        .ApbSlot3Enable(0), 
        .ApbSlot4Enable(0), 
        .ApbSlot5Enable(0), 
        .ApbSlot6Enable(0), 
        .ApbSlot7Enable(0), 
        .ApbSlot8Enable(0), 
        .ApbSlot9Enable(0)
    )
    CoreAPB_00(
        // Inputs
        .PADDR(APBmaster_PADDR),
        .PENABLE(APBmaster_PENABLE),
        .PRDATAS0(APBmslave0_PRDATA),
        .PRDATAS1({32{1'b0}}),
        .PRDATAS10({32{1'b0}}),
        .PRDATAS11({32{1'b0}}),
        .PRDATAS12({32{1'b0}}),
        .PRDATAS13({32{1'b0}}),
        .PRDATAS14({32{1'b0}}),
        .PRDATAS15({32{1'b0}}),
        .PRDATAS2({32{1'b0}}),
        .PRDATAS3({32{1'b0}}),
        .PRDATAS4({32{1'b0}}),
        .PRDATAS5({32{1'b0}}),
        .PRDATAS6({32{1'b0}}),
        .PRDATAS7({32{1'b0}}),
        .PRDATAS8({32{1'b0}}),
        .PRDATAS9({32{1'b0}}),
        .PSELECT(APBmaster_PSELECT),
        .PWDATA(APBmaster_PWDATA),
        .PWRITE(APBmaster_PWRITE),
        // Outputs
        .PADDRS(APBmslave0_PADDR),
        .PENABLES(APBmslave0_PENABLE),
        .PRDATA(APBmaster_PRDATA),
        .PSELS0(APBmslave0_PSELx),
        .PSELS1(),
        .PSELS10(),
        .PSELS11(),
        .PSELS12(),
        .PSELS13(),
        .PSELS14(),
        .PSELS15(),
        .PSELS2(),
        .PSELS3(),
        .PSELS4(),
        .PSELS5(),
        .PSELS6(),
        .PSELS7(),
        .PSELS8(),
        .PSELS9(),
        .PWDATAS(APBmslave0_PWDATA),
        .PWRITES(APBmslave0_PWRITE)
    );

//--------------------------------------------------------------------

CoreMP7Bridge #(
        // Configuration parameters
        .DEBUG('d2), 
        .SYNCFIQ(0), 
        .SYNCIRQ(0)
    )
    CoreMP7Bridge_00(
        // Inputs
        .ADDR(MP7_SysIf_ADDR),
        .DBGTDO(MP7_SysIf_DBGTDO),
        .DBGnTDOEN(MP7_SysIf_DBGnTDOEN),
        .HGRANT({1{1'b1}}),
        .HRDATA(AHBmaster_HRDATA),
        .HREADY(AHBmaster_HREADY),
        .HRESP(AHBmaster_HRESP),
        .LOCK(MP7_SysIf_LOCK),
        .NSYSRESET(NSYSRESET),
        .PROT(MP7_SysIf_PROT),
        .RV_TCK(RV_ICE_If_RV_TCK),
        .RV_TDI(RV_ICE_If_RV_TDI),
        .RV_TMS(RV_ICE_If_RV_TMS),
        .RV_nSRST_IN(RV_ICE_If_RV_nSRST_IN),
        .RV_nTRST(RV_ICE_If_RV_nTRST),
        .SIZE(MP7_SysIf_SIZE),
        .SYSCLK(SYSCLK),
        .TRANS(MP7_SysIf_TRANS),
        .UJTAG_TCK(UJTAG_UJTAG_TCK),
        .UJTAG_TDI(UJTAG_UJTAG_TDI),
        .UJTAG_TMS(UJTAG_UJTAG_TMS),
        .UJTAG_TRSTB(UJTAG_UJTAG_TRSTB),
        .WDATA(MP7_SysIf_WDATA),
        .WDOGRES({1{1'b0}}),
        .WRITE(MP7_SysIf_WRITE),
        .nFIQ_in({1{1'b1}}),
        .nIRQ_in({1{1'b1}}),
        // Outputs
        .ABORT(MP7_SysIf_ABORT),
        .CLK(MP7_SysIf_CLK),
        .CLKEN(MP7_SysIf_CLKEN),
        .DBGTCKEN(MP7_SysIf_DBGTCKEN),
        .DBGTDI(MP7_SysIf_DBGTDI),
        .DBGTMS(MP7_SysIf_DBGTMS),
        .DBGnTRST(MP7_SysIf_DBGnTRST),
        .HADDR(AHBmaster_HADDR),
        .HBURST(AHBmaster_HBURST),
        .HBUSREQ(),
        .HLOCK(),
        .HPROT(AHBmaster_HPROT),
        .HRESETn(HRESETN),
        .HSIZE(AHBmaster_HSIZE),
        .HTRANS(AHBmaster_HTRANS),
        .HWDATA(AHBmaster_HWDATA),
        .HWRITE(AHBmaster_HWRITE),
        .RDATA(MP7_SysIf_RDATA),
        .RV_RTCK(RV_ICE_If_RV_RTCK),
        .RV_TDOUT(RV_ICE_If_RV_TDOUT),
        .RV_nTDOEN(RV_ICE_If_RV_nTDOEN),
        .UJTAG_TDO(UJTAG_UJTAG_TDO),
        .WDOGRESn(),
        .nFIQ(MP7_SysIf_nFIQ),
        .nIRQ(MP7_SysIf_nIRQ),
        .nRESET(MP7_SysIf_nRESET)
    );

//--------------------------------------------------------------------

A7S CoreMP7_00(
        // Inputs
        .ABORT(MP7_SysIf_ABORT),
        .CFGBIGEND({1{1'b0}}),
        .CLK(MP7_SysIf_CLK),
        .CLKEN(MP7_SysIf_CLKEN),
        .CPA({1{1'b1}}),
        .CPB({1{1'b1}}),
        .DBGBREAK({1{1'b0}}),
        .DBGEN({1{1'b1}}),
        .DBGEXT({2{1'b0}}),
        .DBGRQ({1{1'b0}}),
        .DBGTCKEN(MP7_SysIf_DBGTCKEN),
        .DBGTDI(MP7_SysIf_DBGTDI),
        .DBGTMS(MP7_SysIf_DBGTMS),
        .DBGnTRST(MP7_SysIf_DBGnTRST),
        .RDATA(MP7_SysIf_RDATA),
        .nFIQ(MP7_SysIf_nFIQ),
        .nIRQ(MP7_SysIf_nIRQ),
        .nRESET(MP7_SysIf_nRESET),
        // Outputs
        .ADDR(MP7_SysIf_ADDR),
        .CPSEQ(),
        .CPTBIT(),
        .CPnI(),
        .CPnMREQ(),
        .CPnOPC(),
        .CPnTRANS(),
        .DBGACK(),
        .DBGCOMMRX(),
        .DBGCOMMTX(),
        .DBGINSTRVALID(),
        .DBGRNG(),
        .DBGTDO(MP7_SysIf_DBGTDO),
        .DBGnEXEC(),
        .DBGnTDOEN(MP7_SysIf_DBGnTDOEN),
        .DMORE(),
        .LOCK(MP7_SysIf_LOCK),
        .PROT(MP7_SysIf_PROT),
        .SIZE(MP7_SysIf_SIZE),
        .TRANS(MP7_SysIf_TRANS),
        .WDATA(MP7_SysIf_WDATA),
        .WRITE(MP7_SysIf_WRITE)
    );

//--------------------------------------------------------------------

CoreMemCtrl #(
        // Configuration parameters
        .FLASH_16BIT(0), 
        .NUM_WS_FLASH_READ('d3), 
        .NUM_WS_FLASH_WRITE('d3), 
        .NUM_WS_SRAM_READ('d2), 
        .NUM_WS_SRAM_WRITE('d2), 
        .SHARED_RW(0), 
        .SYNC_SRAM(0)
    )
    CoreMemCtrl_00(
        // Inputs
        .HADDR(CoreAHBLite_00_HADDRS[27:0]),
        .HCLK(SYSCLK),
        .HREADYIN(CoreAHBLite_00_HREADYS),
        .HRESETn(HRESETN),
        .HSELflash(AHBmslave0_HSELx),
        .HSELsram(AHBmslave1_00_HSELx),
        .HSIZE(CoreAHBLite_00_HSIZES),
        .HTRANS(CoreAHBLite_00_HTRANSS),
        .HWDATA(CoreAHBLite_00_HWDATAS),
        .HWRITE(CoreAHBLite_00_HWRITES),
        // Outputs
        .FlashCSN(ExternalMemoryInterface_FlashCSN),
        .FlashOEnN(ExternalMemoryInterface_FlashOEnN),
        .FlashWEnN(ExternalMemoryInterface_FlashWEnN),
        .HRDATAflash(AHBmslave0_HRDATA),
        .HRDATAsram(AHBmslave1_00_HRDATA),
        .HREADYflash(AHBmslave0_HREADYOUT),
        .HREADYsram(AHBmslave1_00_HREADYOUT),
        .HRESPflash(AHBmslave0_HRESP),
        .HRESPsram(AHBmslave1_00_HRESP),
        .MemAddr(ExternalMemoryInterface_MemAddr),
        .MemReadN(ExternalMemoryInterface_MemReadN),
        .MemWriteN(ExternalMemoryInterface_MemWriteN),
        .SramByteN(ExternalMemoryInterface_SramByteN),
        .SramCSN(ExternalMemoryInterface_SramCSN),
        .SramClk(ExternalMemoryInterface_SramClk),
        .SramOEnN(ExternalMemoryInterface_SramOEnN),
        .SramWEnN(ExternalMemoryInterface_SramWEnN),
        // Inouts
        .MemData(ExternalMemoryInterface_MemData)
    );

endmodule

