----------------------------------------------------------------------
-- Created by Actel CoreConsole - Thu Jan 04 10:38:02 2007
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end testbench;

architecture behavioral of testbench is

    constant SYSCLK_PERIOD : time := 100 ns;

    -- Component to test
    component Example
        -- Port list
        port(
            -- Inputs
            APBmslave0_PRDATA : in std_logic_vector(31 downto 0);
            NSYSRESET : in std_logic;
            RV_ICE_If_RV_TCK : in std_logic;
            RV_ICE_If_RV_TDI : in std_logic;
            RV_ICE_If_RV_TMS : in std_logic;
            RV_ICE_If_RV_nSRST_IN : in std_logic;
            RV_ICE_If_RV_nTRST : in std_logic;
            Remap : in std_logic;
            SYSCLK : in std_logic;
            UJTAG_UJTAG_TCK : in std_logic;
            UJTAG_UJTAG_TDI : in std_logic;
            UJTAG_UJTAG_TMS : in std_logic;
            UJTAG_UJTAG_TRSTB : in std_logic;
            -- Outputs
            APBmslave0_PADDR : out std_logic_vector(23 downto 0);
            APBmslave0_PENABLE : out std_logic;
            APBmslave0_PSELx : out std_logic;
            APBmslave0_PWDATA : out std_logic_vector(31 downto 0);
            APBmslave0_PWRITE : out std_logic;
            ExternalMemoryInterface_FlashCSN : out std_logic;
            ExternalMemoryInterface_FlashOEnN : out std_logic;
            ExternalMemoryInterface_FlashWEnN : out std_logic;
            ExternalMemoryInterface_MemAddr : out std_logic_vector(27 downto 0);
            ExternalMemoryInterface_MemReadN : out std_logic;
            ExternalMemoryInterface_MemWriteN : out std_logic;
            ExternalMemoryInterface_SramByteN : out std_logic_vector(3 downto 0);
            ExternalMemoryInterface_SramCSN : out std_logic;
            ExternalMemoryInterface_SramClk : out std_logic;
            ExternalMemoryInterface_SramOEnN : out std_logic;
            ExternalMemoryInterface_SramWEnN : out std_logic;
            HRESETN : out std_logic;
            RV_ICE_If_RV_RTCK : out std_logic;
            RV_ICE_If_RV_TDOUT : out std_logic;
            RV_ICE_If_RV_nTDOEN : out std_logic;
            UJTAG_UJTAG_TDO : out std_logic;
            -- Inouts
            ExternalMemoryInterface_MemData : inout std_logic_vector(31 downto 0)
        );
    end component;

    signal SYSCLK    : std_logic := '0';
    signal NSYSRESET : std_logic;

begin

    process
        variable vhdl_initial : BOOLEAN := TRUE; 

    begin
        if (vhdl_initial) then
            -- Assert system reset
            NSYSRESET <= '0';
            wait for (SYSCLK_PERIOD * 4);

            -- Release system reset
            NSYSRESET <= '1';
            wait;
        else
            wait;
        end if; 
    end process;

    -- SYSCLK signal
    SYSCLK <= not SYSCLK after (SYSCLK_PERIOD / 2);

    -- Instantiate module to test

    Example_0 : Example
        -- Port map
        port map(
            -- Inputs
            APBmslave0_PRDATA => (others => '0'),
            NSYSRESET => NSYSRESET,
            RV_ICE_If_RV_TCK => '0',
            RV_ICE_If_RV_TDI => '0',
            RV_ICE_If_RV_TMS => '1',
            RV_ICE_If_RV_nSRST_IN => '1',
            RV_ICE_If_RV_nTRST => '1',
            Remap => '0',
            SYSCLK => SYSCLK,
            UJTAG_UJTAG_TCK => '0',
            UJTAG_UJTAG_TDI => '0',
            UJTAG_UJTAG_TMS => '0',
            UJTAG_UJTAG_TRSTB => '0',
            -- Outputs
            APBmslave0_PADDR => open,
            APBmslave0_PENABLE => open,
            APBmslave0_PSELx => open,
            APBmslave0_PWDATA => open,
            APBmslave0_PWRITE => open,
            ExternalMemoryInterface_FlashCSN => open,
            ExternalMemoryInterface_FlashOEnN => open,
            ExternalMemoryInterface_FlashWEnN => open,
            ExternalMemoryInterface_MemAddr => open,
            ExternalMemoryInterface_MemReadN => open,
            ExternalMemoryInterface_MemWriteN => open,
            ExternalMemoryInterface_SramByteN => open,
            ExternalMemoryInterface_SramCSN => open,
            ExternalMemoryInterface_SramClk => open,
            ExternalMemoryInterface_SramOEnN => open,
            ExternalMemoryInterface_SramWEnN => open,
            HRESETN => open,
            RV_ICE_If_RV_RTCK => open,
            RV_ICE_If_RV_TDOUT => open,
            RV_ICE_If_RV_nTDOEN => open,
            UJTAG_UJTAG_TDO => open,
            -- Inouts
            ExternalMemoryInterface_MemData => open
        );

end behavioral;
