//**********************************************************************
// Copyright 2002 by SoC Solutions, LLC                                *
// All rights reserved.                                                *
// No portion of this material may be reproduced in any form           *
// without the written permission of SoC Solutions.                    *
// All information contained is SoC Solutions company private,         *
// proprietary, and trade secret.                                      *
//**********************************************************************
// Context:     SoC Solutions IP, Verilog Header for Parallel Port
// Filename:    socParPort.hv
// Author:      Chris Stephens
// Rev:   0.3   07/02/2001 added word aligned address offsets - CJS
//**********************************************************************
// Rev:   0.2   06/14/2001 Comments added- SA
// Rev:   0.1   06/05/2001 renamed file, modified definitions
// Rev:   0.0   05/19/2000 initial edit
/***********************************************************************
   General Description:
                This module provides definitions for the Parallel Port
************************************************************************
*/

// Parallel Port register address offsets:
`define HW_PARALLEL_DATA_OFFSET     'b00    // Access to the parallel data bus
`define HW_PARALLEL_STATUS_OFFSET   'b01    // Status of interrupt and printer inputs
`define HW_PARALLEL_IOSEL_OFFSET    'b01    // Controls direction of port when bidEn input is low
`define HW_PARALLEL_CONTROL_OFFSET  'b10    // Status or interrupt enable and printer outputs
`define HW_PARALLEL_COMMAND_OFFSET  'b10    // Enables interrupt output and drives printer outputs

// corresponding word aligned address offsets:
`define PARALLEL_DATA_OFFSET        `HW_PARALLEL_DATA_OFFSET*4
`define PARALLEL_STATUS_OFFSET      `HW_PARALLEL_STATUS_OFFSET*4
`define PARALLEL_IOSEL_OFFSET       `HW_PARALLEL_IOSEL_OFFSET*4
`define PARALLEL_CONTROL_OFFSET     `HW_PARALLEL_CONTROL_OFFSET*4
`define PARALLEL_COMMAND_OFFSET     `HW_PARALLEL_COMMAND_OFFSET*4
